measureGenesMeanCorrCoef = function(esetBEFORE, esetAFTER, batchAnnot="Batch")
{
	# Some checks
	if(!is.element(batchAnnot,colnames(pData(esetAFTER))))
	{
		err("No batch information provided!")
	}
	nr_studies = length(unique(pData(esetAFTER)[,batchAnnot]))
	if(nr_studies==1)
	{
		err("Only one batch!")
	}
	#Columnwise normalize the data
	temp = t(exprs(esetBEFORE))
	temp = apply(temp, 1, function(x){x-mean(x, na.rm=TRUE)});
  temp = apply(temp, 1, function(x){x/sd(x, na.rm=TRUE)});
	exprs(esetBEFORE) = t(temp)		
	
	temp = t(exprs(esetAFTER))
	temp = apply(temp, 1, function(x){x-mean(x, na.rm=TRUE)});
  temp = apply(temp, 1, function(x){x/sd(x, na.rm=TRUE)});
	exprs(esetAFTER) = t(temp)	

	tot_cc = 0;
	for(study in unique(pData(esetBEFORE)[,batchAnnot]))
	{
		idxB = which(pData(esetBEFORE)[,batchAnnot]==study);
		idxA = which(pData(esetAFTER)[,batchAnnot]==study);

		cur_esetBefore = esetBEFORE[,idxB];
		cur_esetAfter = esetAFTER[,idxA];
		
		cc = mat.or.vec(1,dim(cur_esetBefore)[1]);
		
		for(i in 1:dim(cur_esetBefore)[1])
    {
      cc[i] = cor(exprs(cur_esetBefore)[i,],exprs(cur_esetAfter)[i,])
    }

		tot_cc = tot_cc + sum(abs(cc))/length(cc)
	}
	return(tot_cc / length(unique(pData(esetAFTER)[,batchAnnot])));
}
