measureGenesOverlap = function(eset, batchAnnot="Batch")
{
	# Some checks
	if(!is.element(batchAnnot,colnames(pData(eset))))
	{
		err("No batch information provided!")
	}
	nr_studies = length(unique(pData(eset)[,batchAnnot]))
	if(nr_studies==1)
	{
		err("Only one batch!")
	}
	#Columnwise normalize the data
	#temp = t(exprs(eset))
	#temp = apply(temp, 1, function(x){x-mean(x, na.rm=TRUE)});
  	#temp = apply(temp, 1, function(x){x/sd(x, na.rm=TRUE)});
	#exprs(eset) = t(temp)		

	goIndex = 0;
	for(batch in unique(pData(eset)[,batchAnnot]))
	{
		idx = which(pData(eset)[,batchAnnot]==batch);
		eset1 = eset[,idx];
		eset2 = eset[,-idx];
		
		index = mat.or.vec(1,dim(exprs(eset))[1])
	
		for(i in 1:dim(eset1)[1])
		{
			pdf1 = density(exprs(eset1)[i,], from = (min(min(exprs(eset)[i,]))-5), to = (max(max(exprs(eset)[i,]))+5));
        	pdf1$y = pdf1$y/sum(pdf1$y);
			cdf1 = cumsum(pdf1$y/sum(pdf1$y));
        
        	pdf2 = density(exprs(eset2)[i,], from = (min(min(exprs(eset)[i,]))-5), to = (max(max(exprs(eset)[i,]))+5));
	        pdf2$y = pdf2$y/sum(pdf2$y);
			cdf2 = cumsum(pdf2$y/sum(pdf2$y));
			index[i] = sum ( abs(pdf1$y-pdf2$y) ) /2;
		} 
		cur_goIndex = sum(index)/length(index);
		goIndex = goIndex + cur_goIndex;
	}
	return(goIndex / length(unique(pData(eset)[,batchAnnot])));
}
