measureSamplesOverlap = function(eset, batchAnnot="Batch")
{
	# Some checks
	if(!is.element(batchAnnot,colnames(pData(eset))))
	{
		err("No batch information provided!")
	}
	nr_studies = length(unique(pData(eset)[,batchAnnot]))
	if(nr_studies==1)
	{
		err("Only one batch!")
	}
	#Columnwise normalize the data
	temp = t(exprs(eset))
	temp = apply(temp, 1, function(x){x-mean(x, na.rm=TRUE)});
  	temp = apply(temp, 1, function(x){x/sd(x, na.rm=TRUE)});
	exprs(eset) = t(temp)	

	# Divide the eset in separate eSets per study
	distance = as.matrix(dist(t(exprs(eset))))
	distance[cbind(1:ncol(exprs(eset)),1:ncol(exprs(eset)))]=Inf
	tot_dist = 0;
	for(i in 1:ncol(exprs(eset)))
	{
		min_dist = min(distance[i,-which(pData(eset)[,batchAnnot]==pData(eset)[i,batchAnnot])])
		tot_dist = tot_dist + min_dist / (length(which(pData(eset)[,batchAnnot]==pData(eset)[i,batchAnnot])));
	}
	avg_dist = tot_dist / nr_studies;
	return(avg_dist);
}
