mergeGENESHIFT = function(esets)
{	
  # Make sure genes are in same order in all studies
  esets = lapply(esets, function(x){ x[sort(rownames(exprs(x)))]; });
  esets = commonGenes(esets);
  
  # print(esets)

  # TODO pick the one with the biggest number of samples ??
  # We select the first eset as 'reference' eset
  esetRef = esets[[1]];
  refPdfs = apply(exprs(esetRef),1,function(x){density(x,from=0,to=15);});
  
  #epsilon = 0;
  
  # default period of density function = length(density(c(1,2))$y)
  pdf = refPdfs[[1]];
  period = length(pdf$y);
  #print(period)

  newEsets = list(esetRef);
  for(eset in esets[-1])
  {
    esetPdfs = apply(exprs(eset),1,function(x){density(x,from=0,to=15);});
    
    nrow = nrow(exprs(eset));
    offset = rep(0, nrow);

    #-(1)-- Calculate offset for each gene
    for(r in 1:nrow)
    {
    	
      # define a window where the second pdf moves
      window = rep(0,period);
      score = rep(0,period*2-1);
		
      pdf = esetPdfs[[r]]; pdf$y = pdf$y; 
      pdfRef = refPdfs[[r]]; pdfRef$y = pdfRef$y;
      
      #_______________________________
      # quartz()
      # plot(pdfRef)
      
      # quartz()
      # plot(pdf)
      #_______________________________
      
        #_________________________________________________
    	
    	W = mat.or.vec(2*period,period);
    	
    	for(i in 1:period-1)
    	{
    		
    		W[i,1:i] = pdf$y[(period-(i-1)):period]; 
    		#score[i] = sum(abs(pdfRef$y-W[i,]))/period;
    		score[i] = sum(pdfRef$y*W[i,]);
    		#score[i] = sum(log(1+abs(pdfRef$y-W[i,])));
    		#score[i] = ((sum(abs(pdfRef$y-W[i,])^(5)))^(1/5))/period;
    		#score[i] = max(abs(pdfRef$y-W[i,]));
    		#score[i] = -sum(pdfRef$y*log(W[i,]))/period + sum(pdfRef$y*log(pdfRef$y))/period;
    		#score[i] = sum( (pdfRef$y)*log( 2*pdfRef$y/(pdfRef$y+W[i,]) ) );
    		
    		W[i+period,(i+1):period] = pdf$y[1:(period-i)]; 
    		#score[i+period] = sum(abs(pdfRef$y-W[i+period,]))/period;
    		score[i+period] = sum(pdfRef$y*W[i+period,]);
    		#score[i+period] = sum(log(1+abs(pdfRef$y-W[i+period,])));
    		#score[i+period] = ((sum(abs(pdfRef$y-W[i+period,])^(5)))^(1/5))/period;
    		#score[i+period] = max(abs(pdfRef$y-W[i+period,]));
    		#score[i+period] = -sum(pdfRef$y*log(W[i+period]))/period + sum(pdfRef$y*log(pdfRef$y))/period;
    		#score[i+period] = sum( (pdfRef$y)*log( 2*pdfRef$y/(pdfRef$y+W[i+period,]) ) );
    		
    	}
    	W[period,] = pdf$y; 
    	#score[period] = sum(abs(pdfRef$y-W[period,]))/period;
    	score[period] = sum(pdfRef$y*W[period,]);
    	#score[period] = sum(log(1+abs(pdfRef$y-W[period,])));
    	#score[period] = ((sum(abs(pdfRef$y-W[period,])^(5)))^(1/5))/period;
    	#score[period] = max(abs(pdfRef$y-W[period,]));
    	#score[period] = -sum(pdfRef$y*log(W[period]))/period + sum(pdfRef$y*log(pdfRef$y))/period;
    	#score[period] = sum( (pdfRef$y)*log( 2*pdfRef$y/(pdfRef$y+W[period,]) ) );
    	
    	#score[2*period] = sum(abs(pdfRef$y-W[2*period,]))/period;
    	#score[2*period] = max(abs(pdfRef$y-W[2*period,]));
    	#score[2*period] = -sum(pdfRef$y*log(W[2*period]))/period + sum(pdfRef$y*log(pdfRef$y))/period;
    	#score[2*period] = sum( (pdfRef$y)*log( 2*pdfRef$y/(pdfRef$y+W[2*period,]) ) );

    	# quartz()
    	# plot(score)
    	#_________________________________________________
 
      # # Calculate difference between first half of window and reference pdf
	# for(p in 1:period)
      # {
        # window[1:p] = pdf$y[(period-p+1):period];
        # score[p] = sum(abs(pdfRef$y-window))/period;
		# #score[p] = -sum(pdfRef$y*log(window))/period + sum(pdfRef$y*log(pdfRef$y))/period;
      # }
      
      # # Calculate difference between second half of window and reference pdf
		  # count = 0;
		  # for(p in (period+1):(2*period))
			# {
				# count = count+1;
				# window[p:(p+p-period-1)] = 0;
				# window[(p+1):(2*period)] = pdf$y[1:(period-count)];
				# score[p] = sum(abs(pdfRef$y-window[(period+1):(2*period)]))/period;
				# #score[p] = -sum(pdfRef$y*log(window[(period+1):(2*period)]))/period + sum(pdfRef$y*log(pdfRef$y))/period;
			# }

      # Find offset which corresonds with minimum score			
      
		  #idx = which(score==min(score))[1];
		  idx = which(score==max(score));
	    if(idx==period) { offset[r] = 0; }
		  else { offset[r] = sign(period-idx) * pdfRef$x[abs(period-idx)]; }
	  }
   
	  #-(2)-- Subtract the offset for each gene
	  for(r in 1:nrow)
	  {
		  if(offset[r] <= 0) {exprs(eset)[r,] = exprs(eset)[r,]+abs(offset[r]);}
		  if(offset[r] > 0) {exprs(eset)[r,] = exprs(eset)[r,]-offset[r];}
	  }
	  
      newEsets[[length(newEsets)+1]] = eset;
  
  }

#_____________________
  #quartz()
  #plot(offset)	
  #print(offset)
  #print(W)
#_____________________
  
  return(mergeNONE(newEsets));
}
