# plot dendrogram
#-------------------------------------------------------------------------------
plotDendrogram = function(eset, batchAnnot="Batch", legend=TRUE, file=NULL, ...)
{
  if(! is.null(file)) { pdf(file, width=12, height=7); }

  #--Add margin to the right for the legend 
  tmp = par()$mar;
  if(legend) { par(xpd=T, mar=par()$mar+c(0,0,0,8)); }
 
  #--Create clustering
  hc = hcluster(t(exprs(eset)), method="pearson");
  hc$labels = as.numeric(pData(eset)[,batchAnnot]);

  #--Plot tree
  plot(hc,
       panel.first={U = par("usr");
                    rect(U[1],U[3],U[2],U[4],
                         col="azure2",
                         border="black",
                         lwd=3);},
       xlab="", ylab="", sub="", axes=FALSE,
       ...);

  #--Reset margin
  if(legend) { par(xpd=F, mar=tmp) }
  
  if(! is.null(file)) { dev.off(); }
}
